/**
 * CodePresenter Plugin
 * Dependencies (jQuery, Precode.Base, Precode.Highlight)
 * http://insteps.net
 *
 * @version 2.2.0
 * @copyright Copyright (c) 2012-2023 V.Krishn. All rights reserved.
 * @license GPL License
 *
 * This file is part of Cookbook recipe "Precode" for PmWiki;
 * See accompanying package for license and more details.
 * Package: http://insteps.net/pr/a/pmwiki/Cookbook/Precode
 */

(function(Precode, $, undefined)
{
  if(typeof $.fn == 'undefined') { return; }
  var CodePresenter = Precode.CodePresenter = {

    numx : -1,
    setkeys : function (e) {
      switch(e.keyCode) {
        case 38:
          c.numx--;
          if( c.numx < 0) { c.numx = c.hilites.length; }
          c.sethilite();
        break;
        case 40:
          c.right(); c.sethilite();
        break;
        case 37:
          if(c.activekey === e.keyCode) {
             $(c.currentline).removeClass(c.hs);
               c.left(); c.sethilite();
            } else { $(c.currentline).addClass(c.h).removeClass(c.hs); }
        break;
        case 39:
          if(c.activekey === e.keyCode) {
            $(c.currentline).addClass(c.hs);
            c.right(); c.sethilite();
          } else { $(c.currentline).removeClass(c.h).addClass(c.hs); }
        break;
      }
    },

    left : function () {
      c.numx--; if( c.numx < 0) { c.numx = 0; }
    },
    right : function () {
      c.numx++; if(c.numx > c.hilites.length) { c.numx = -1; }
    },
 
    sethilite : function () {

      if( c.activepre == undefined ) { return false; }
      var n = c.numx; var nh = c.hilites[n];
      $(c.currentline).removeClass(c.h);
      $(nh).addClass(c.h); c.currentline = nh;

    },

    init: function (obj) {

      c = CodePresenter;
      if (obj.firstChild.tagName !== 'CODE') { return; }

      if(c.activepre != undefined
        && ! $(obj).hasClass(c.ha) )
      {
        $(c.activepre).removeClass(c.ha);
        if(c.hilites.length) c.hilites.removeClass(c.h); c.numx = -1;
      }

      c.activepre = obj;
      c.layer = c.activepre.firstChild.nextSibling;
      c.hilites = $(c.layer).children();
      c.currentline = c.hilites[c.numx];

      if($(obj).hasClass(c.ha)) {
        $(obj).removeClass(c.ha);
      } else {
        $(obj).addClass(c.ha);
        c.currentline = c.hilites[0];
      }

    }

  }

  $.fn.CodePresenter = function() {

    c = CodePresenter;
    c.hilites = {};
    c.h = 'hilite';
    c.hs = 'stayhilite';
    c.ha = 'active';
    
    this.dblclick(function(e) { $(document).unbind('keydown'); });
    this.click(function(e) {
      $(document).unbind('keydown');
      $(document).keydown(function(e) {
        if( e.keyCode > 36 && e.keyCode < 41 ) {
          c.setkeys(e); c.activekey = e.keyCode; return false; }
      });
      c.init(this);
      e.preventDefault();
    });
    return c;

  };

})(Precode, jQuery = window.jQuery || {});

//$('pre').CodePresenter();

